using System;
using NxCoreAPI;
class CategorySample {

	static unsafe int OnNxCoreCallback(NxCoreSystem* pNxCoreSys, NxCoreMessage* pNxCoreMsg) {
		if (pNxCoreMsg->MessageType == NxCore.NxMSG_CATEGORY) {
			NxCoreHeader* pHeader = &pNxCoreMsg->coreHeader;
			var symbol = new String(&pHeader->pnxStringSymbol->String);
			NxTime* pTimestamp = &pHeader->nxExgTimestamp;
			NxDate* pSessionDate = &pHeader->nxSessionDate;
			
			NxCoreCategory* pCategory = &pNxCoreMsg->coreData.Category;
			int categoryID = pCategory->pnxStringCategory->Atom;
			NxCategoryField* pFields = pCategory->pnxFields;

			if (categoryID == 4) {
				if (pFields[0].Set == 1) {
					var name = new String(pFields[0].data.StringZ);
					Console.WriteLine("{0:s} name is {1:s}", symbol, name);
				}
			}
			if (categoryID == 50 || categoryID == 52 || categoryID == 54) {
				double high = 0.0;
				double low = 0.0;
				double last = 0.0;
				long volume = 0;
				if (pFields[2].Set == 1)
					high = NxCore.PriceToDouble(pFields[2].data.nxPrice.Price, pFields[2].data.nxPrice.PriceType);
				if (pFields[3].Set == 1)
					low = NxCore.PriceToDouble(pFields[3].data.nxPrice.Price, pFields[3].data.nxPrice.PriceType);
				if (pFields[4].Set == 1)
					last = NxCore.PriceToDouble(pFields[4].data.nxPrice.Price, pFields[4].data.nxPrice.PriceType);
				if (pFields[6].Set == 1)
					volume = pFields[6].data.i64Bit;
				Console.WriteLine("{0:s} on {1:d}{2:d2}{3:d2} had a high of ${4:f2}, low of ${5:f2}, last of ${6:f2}, and volume of {7:d} shares",
					symbol, pSessionDate->Year, pSessionDate->Month, pSessionDate->Day, high, low, last, volume);
			}
	  	}
		return NxCore.NxCALLBACKRETURN_CONTINUE;
	}

	static unsafe void Main(string[] args) {
		if (args.Length < 1)
			return;
		int returnValue = NxCore.ProcessTape(args[0], null, 0, 0, CategorySample.OnNxCoreCallback);
		NxCore.processReturnValue(returnValue);
	}
}
