using System;
using NxCoreAPI;

class QuoteSample {
	static unsafe int OnNxCoreCallback(NxCoreSystem* pNxCoreSys, NxCoreMessage* pNxCoreMsg) {
		if (pNxCoreMsg->MessageType == NxCore.NxMSG_EXGQUOTE) {
			NxCoreHeader* pHeader = &pNxCoreMsg->coreHeader;
			String symbol = new String(&pHeader->pnxStringSymbol->String);
			NxTime* pTimestamp = &pHeader->nxExgTimestamp;
			String exchange = new String(NxCore.GetDefinedString(NxCore.NxST_EXCHANGE, pHeader->ReportingExg));
			
			NxCoreQuote* pCoreQuote = &pNxCoreMsg->coreData.ExgQuote.coreQuote;
			int sizeBid = pCoreQuote->BidSize;
			int sizeAsk = pCoreQuote->AskSize;
			double priceBid = NxCore.PriceToDouble(pCoreQuote->BidPrice, pCoreQuote->PriceType);
			double priceAsk = NxCore.PriceToDouble(pCoreQuote->AskPrice, pCoreQuote->PriceType);
			
			Console.WriteLine("Quote for {0:s} on Exchange {1:s} at {2:d2}:{3:d2}:{4:d2} Bid: {5:d} lots at ${6:f2} Ask: {7:d} lots at ${8:f2}",
				symbol, exchange, pTimestamp->Hour, pTimestamp->Minute, pTimestamp->Second,
				sizeBid, priceBid, sizeAsk, priceAsk);
	  	}
		return NxCore.NxCALLBACKRETURN_CONTINUE;
	}

	static unsafe void Main(string[] args) {
		if (args.Length < 1)
			return;
		int returnValue = NxCore.ProcessTape(args[0], null, 0, 0, QuoteSample.OnNxCoreCallback);
		NxCore.processReturnValue(returnValue);
	}
}
