using System;
using NxCoreAPI;

class StatusSample {
	static unsafe int OnNxCoreCallback(NxCoreSystem* pNxCoreSys, NxCoreMessage* pNxCoreMsg) {
		if (pNxCoreMsg->MessageType == NxCore.NxMSG_STATUS) {
			if (pNxCoreSys->ClockUpdateInterval >= NxCore.NxCLOCK_MINUTE) {
				int year = pNxCoreSys->nxDate.Year;
				int month = pNxCoreSys->nxDate.Month;
				int day = pNxCoreSys->nxDate.Day;
				int hour = pNxCoreSys->nxTime.Hour;
				int minute = pNxCoreSys->nxTime.Minute;
				Console.WriteLine("{0:d2}/{1:d2}/{2:d} {3:d2}:{4:d2}", month, day, year, hour, minute);
			}

			if (pNxCoreSys->Status == NxCore.NxCORESTATUS_WAITFORCOREACCESS)
				Console.WriteLine("Waiting on NxCore Access");

			if (pNxCoreSys->Status == NxCore.NxCORESTATUS_ERROR)
				Console.WriteLine("tape error:{0:d}", pNxCoreSys->StatusData);

			if (pNxCoreSys->Status == NxCore.NxCORESTATUS_INITIALIZING) {
				int major = NxCore.GetMajorVersion(pNxCoreSys->DLLVersion);
				int minor = NxCore.GetMinorVersion(pNxCoreSys->DLLVersion);
				int build = NxCore.GetBuildVersion(pNxCoreSys->DLLVersion);
				Console.WriteLine("Initialized with decoder version {0:d}.{1:d}.{2:d}", major, minor, build);
			}
		}
		return NxCore.NxCALLBACKRETURN_CONTINUE;
	}

	static unsafe void Main(string[] args) {
		if (args.Length < 1)
			return;
		int returnValue = NxCore.ProcessTape(args[0], null, 0, 0, StatusSample.OnNxCoreCallback);
		NxCore.processReturnValue(returnValue);
	}
}

