using System;
using NxCoreAPI;

class SymbolSample {

	static unsafe int OnNxCoreCallback(NxCoreSystem* pNxCoreSys, NxCoreMessage* pNxCoreMsg) {
		if (pNxCoreMsg->MessageType == NxCore.NxMSG_SYMBOLSPIN) {
			NxCoreHeader* pHeader = &pNxCoreMsg->coreHeader;
			String symbol = new String(&pHeader->pnxStringSymbol->String);
			NxTime* pTimestamp = &pHeader->nxExgTimestamp;
			String exchange = new String(NxCore.GetDefinedString(NxCore.NxST_EXCHANGE, pHeader->ListedExg));
			
			Console.WriteLine("symbol {0:s} is listed on {1:s}", symbol, exchange);
	  	}
		if(pNxCoreMsg->MessageType == NxCore.NxMSG_SYMBOLCHANGE && pNxCoreMsg->coreData.SymbolChange.Status == NxCore.NxSS_ADD) {
			NxCoreHeader* pHeader = &pNxCoreMsg->coreHeader;
			String symbol = new String(&pHeader->pnxStringSymbol->String);
			NxTime* pTimestamp = &pHeader->nxExgTimestamp;
			String exchange = new String(NxCore.GetDefinedString(NxCore.NxST_EXCHANGE, pHeader->ListedExg));

			Console.WriteLine("new symbol {0:s} is listed on {1:s}", symbol, exchange);
		}
		return NxCore.NxCALLBACKRETURN_CONTINUE;
	}

	static unsafe void Main(string[] args) {
		if (args.Length < 1)
			return;
		int returnValue = NxCore.ProcessTape(args[0], null, 0, 0, SymbolSample.OnNxCoreCallback);
		NxCore.processReturnValue(returnValue);
	}
}
