using System;
using NxCoreAPI;
class tradeSample {

	static unsafe int OnNxCoreCallback(NxCoreSystem* pNxCoreSys, NxCoreMessage* pNxCoreMsg) {
		if (pNxCoreMsg->MessageType == NxCore.NxMSG_TRADE) {

            NxCoreHeader* pHeader = &pNxCoreMsg->coreHeader;
            String symbol = new String(&pHeader->pnxStringSymbol->String);
            NxTime* pTimestamp = &pHeader->nxExgTimestamp;
            
            NxCoreTrade* pTrade = &pNxCoreMsg->coreData.Trade;
            double price = NxCore.PriceToDouble(pTrade->Price, pTrade->PriceType);
            uint size = pTrade->Size;

            Console.WriteLine("Trade for {0:s} at {1:d2}:{2:d2}:{3:d2} {4:d} shares at ${5:f2}",
			    symbol, pTimestamp->Hour, pTimestamp->Minute, pTimestamp->Second, size, price);
		}
		return NxCore.NxCALLBACKRETURN_CONTINUE;
	}

	static unsafe void Main(string[] args) {
		if (args.Length < 1)
			return;
		int returnValue = NxCore.ProcessTape(args[0], null, 0, 0, tradeSample.OnNxCoreCallback);
		NxCore.processReturnValue(returnValue);
	}
}
